SystemOrganization addCategory: #Quickprototypingcommon!
SystemOrganization addCategory: 'Quickprototypingcommon-QuickPrototypingCommon'!

!PlainGroupboxMorph methodsFor: '*quickprototypingcommon' stamp: 'HwaJong 8/18/2013 14:45'!
beHorizontalFilling
	self halt beHorizontalFillingWithHeight: ((self submorphs collect: #height) min + self mysteriousPadding)! !

!PlainGroupboxMorph methodsFor: '*quickprototypingcommon' stamp: 'HwaJong 8/18/2013 14:44'!
mysteriousPadding
	^10! !

!Object methodsFor: '*quickprototypingcommon' stamp: 'HwaJong 1/4/2013 00:24'!
alwaysTrue
	^true! !

Object subclass: #QuickPrototyping
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuickPrototypingCommon'!

!QuickPrototyping class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/4/2013 00:39'!
for: anObject
	^self new model: anObject! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/4/2013 00:23'!
button: aString action: aSymbol
	^UITheme builder newButtonFor: model action: aSymbol label: aString help: nil! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/21/2014 04:31'!
button: aString action: aSymbol enabled: secondSymbol

	^UITheme builder newButtonFor: model action: aSymbol getEnabled: secondSymbol label: aString help: nil! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/31/2014 01:45'!
buttonGetLabel: getLabelSym action: aSymbol 
	^self buttonGetLabel: getLabelSym action: aSymbol enabled: nil! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/31/2014 01:45'!
buttonGetLabel: getLabelSym action: aSymbol enabled: symbol2
	^UITheme builder newButtonFor: model getState: nil action: aSymbol arguments: nil getEnabled: symbol2 getLabel: getLabelSym help: nil! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 3/1/2014 23:03'!
checkbox: aString accessor: aSymbol 
	^self checkbox: aString accessor: aSymbol enabled: nil! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 3/1/2014 23:02'!
checkbox: aString accessor: aSymbol enabled: enableSymbol
	^UITheme builder newCheckboxFor: model getSelected: aSymbol setSelected: (aSymbol , ':') asSymbol getEnabled: enableSymbol label: aString help: nil.! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 3/1/2014 23:03'!
checkbox: aString action: aSymbol 
	self deprecated: 'use checkbox:accessor: '.
	^UITheme builder newCheckboxFor: model getSelected: aSymbol setSelected: (aSymbol , ':') asSymbol label: aString help: nil! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 6/14/2013 11:36'!
color: aSymbol 
	^UITheme builder newColorChooserFor: model getColor: aSymbol setColor: ((aSymbol, ':') asSymbol) help: nil! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/31/2013 12:13'!
color: symbol1 enable: symbol2
	"^UITheme builder newColorPresenterFor: model getColor: aSymbol help: nil"
	"^UITheme builder newColorChooserFor: model getColor: aSymbol setColor: ((aSymbol, ':') asSymbol) help: nil."
	^UITheme builder newColorChooserFor: model getColor: symbol1 setColor: ((symbol1, ':') asSymbol) getEnabled: symbol2 help: nil! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/31/2013 23:40'!
column: anArray 
	^(UITheme builder newColumn: anArray)
	! !

!QuickPrototyping methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:47'!
dropList: aString 
	^(UITheme builder newDropListFor: model list: (aString , 'DropList') asSymbol getSelected: (aString, 'DropListIndex') asSymbol setSelected: (aString, 'DropListIndex:') asSymbol help: nil)! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 6/14/2013 12:34'!
fastList: aSymbol

	^self
		fastListSize: (aSymbol, 'ListSize') asSymbol 
		element: (aSymbol, 'ListElementAt:') asSymbol 
		index: (aSymbol , 'ListIndex') asSymbol ! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 6/14/2013 12:44'!
fastListSize: sym1 element: sym2 index: sym3
	[sym2 numArgs = 1] assert.
	^(UITheme builder newListFor: (self model)
		list: nil
		selected: sym3
		changeSelected: (sym3 , ':') asSymbol
		help: nil)
			getListSizeSelector: sym1;
			getListElementSelector: sym2;
			yourself! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/29/2014 14:57'!
fastMultiList: aSymbol

	^self 
		fastMultiListSize: (aSymbol, 'ListSize') asSymbol 
		element: (aSymbol, 'ListElementAt:') asSymbol  
		index: (aSymbol , 'ListIndex') asSymbol! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/30/2014 20:23'!
fastMultiListSize: symbol1 element: symbol2 index: symbol3
	|bl|
	[symbol2 numArgs = 1] assert.
	bl := PluggableMultiColumnListMorph on: model list: nil selected: symbol3 changeSelected: (symbol3, ':') asSymbol menu: nil wrapSelector: nil.
	bl getListSizeSelector: symbol1; getListElementSelector: symbol2.
	bl beSpaceFilling.
	bl autoDeselect: false.
	^bl! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/6/2013 18:20'!
group: aMorph 
	^self grouped: aMorph! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/6/2013 18:19'!
grouped: aMorph 
	^UITheme builder newGroupboxFor: aMorph! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/6/2013 18:21'!
grouped: aString column: anArray 
	^self grouped: aString for: (self column: anArray)
	! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/6/2013 18:21'!
grouped: aString for: aMorph
	^UITheme builder newGroupbox: aString for: aMorph! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/6/2013 18:21'!
grouped: aString panel2D: anArray 
	^self grouped: aString for: (self panel2D: anArray)! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/14/2013 13:00'!
grouped: aString row: anArray 
	^self grouped: aString for: (self row: anArray)
	! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/6/2013 18:22'!
groupedColumn: anArray 
	^self grouped: (self column: anArray)! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/6/2013 18:22'!
groupedRow: anArray 
	^self grouped: (self row: anArray)! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/4/2013 00:21'!
label: aSymbol
	^UITheme builder newLabelFor: model getLabel: aSymbol getEnabled: #alwaysTrue.! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 2/5/2013 14:27'!
list: aSymbol 
	^self list: ((aSymbol, 'List') asSymbol) index: ((aSymbol, 'ListIndex') asSymbol)! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/4/2013 13:42'!
list: listGetter index: indexGetter
	^self list: listGetter index: indexGetter width: 90! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/4/2013 13:41'!
list: listGetter index: indexGetter width: anInteger
	^(UITheme builder newListFor: model list: listGetter selected: indexGetter changeSelected: (indexGetter , ':') asSymbol help: nil) minWidth: anInteger! !

!QuickPrototyping methodsFor: 'accessing' stamp: 'HwaJong 1/4/2013 00:19'!
model
	^ model! !

!QuickPrototyping methodsFor: 'accessing' stamp: 'HwaJong 1/4/2013 00:19'!
model: anObject
	model := anObject! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 2/5/2013 18:53'!
morphList: aSymbol 
	^self morphList: ((aSymbol, 'List') asSymbol) index: ((aSymbol, 'ListIndex') asSymbol)! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 2/5/2013 18:54'!
morphList: aSymbol index: aSymbol2 
	^UITheme builder newMorphListFor: model list: aSymbol getSelected: aSymbol2 setSelected: ((aSymbol2,':') asSymbol) getEnabled: nil help: nil! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 3/3/2013 10:15'!
multiList: aByteSymbol 
	|bl|
	bl := PluggableMultiColumnListMorph on: model list: aByteSymbol selected: nil changeSelected: nil menu: nil wrapSelector: #yourself.
	^bl beSpaceFilling! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 3/13/2013 18:11'!
multiList: aByteSymbol index: aByteSymbol2 
	^self multiList: aByteSymbol  index: aByteSymbol2 wrap: #yourself! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/14/2013 16:50'!
multiList: aByteSymbol index: aByteSymbol2 width: aSmallInteger 
	^(self multiList: aByteSymbol  index: aByteSymbol2) minWidth: aSmallInteger! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 3/13/2013 18:11'!
multiList: symbol1 index: symbol2 wrap: symbol3 
	|bl|
	bl := PluggableMultiColumnListMorph on: model list: symbol1 selected: symbol2 changeSelected: (symbol2, ':') asSymbol menu: nil wrapSelector: symbol3.
	^bl! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/16/2013 15:52'!
multiList: aByteSymbol width: aSmallInteger 
	^(self multiList: aByteSymbol) minWidth: aSmallInteger! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 6/10/2013 15:34'!
notSelectingMorphList: aSymbol
	^UITheme builder newMorphListFor: model list: aSymbol getSelected: nil setSelected: nil getEnabled: nil help: nil! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/4/2013 00:28'!
panel2D: anArray 
	^self column: (anArray collect: [:arr | self row: arr ])! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 6/14/2013 11:40'!
row: anArray 
	^(UITheme builder newRow: anArray)! !

!QuickPrototyping methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/27/2014 17:43'!
splitLeft: morph1 splitRight: morph2

	| mother splitter delta |
	splitter := ProportionalSplitterMorph new.
	splitter addLeftOrTop: morph1.
	splitter addRightOrBottom: morph2.

	mother := self row: { morph1. splitter. morph2 }.
	delta := 2.

	mother
		addMorph: morph1
		fullFrame: ( (0@0 corner: 0.5@1) asLayoutFrame 
						bottomRightOffset: (delta negated)@0).
	mother
		addMorph: splitter
		fullFrame:  ((0.5@0 corner: 0.5@1) asLayoutFrame 
						topLeftOffset: (delta negated)@0;  bottomRightOffset: delta@0).
	mother 
		addMorph: morph2
		fullFrame: ( (0.5@0 corner: 1@1) asLayoutFrame 
						topLeftOffset: (delta@0)).
	mother layoutPolicy: ProportionalLayout new.
	^mother! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/4/2013 01:03'!
staticLabel: aString 
	^UITheme builder newLabel: aString! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/4/2013 23:33'!
text: aByteSymbol 
	^self text: aByteSymbol width: 53! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 2/24/2013 11:50'!
text: aByteSymbol width: aNumber
	^(UITheme builder newTextEntryFor: model getText: aByteSymbol setText: (aByteSymbol , ':') asSymbol getEnabled: nil help: nil) minWidth: aNumber; acceptOnFocusChange: true! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/30/2013 16:52'!
title: aString color: aSymbol 
	^self groupedRow: {self staticLabel: aString. self color: aSymbol}! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/31/2013 12:13'!
title: aString color: symbol1 enable: symbol2
	^self groupedRow: {self staticLabel: aString. self color: symbol1 enable: symbol2}! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 8/18/2013 14:47'!
title: aString label: aSymbol 
	|gb|
	gb := self groupedRow: {self staticLabel: aString. self label: aSymbol}.
	gb beHorizontalFillingWithHeight: 24.
	^gb! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/4/2013 23:35'!
title: aByteString text: aByteSymbol 
	^self groupedRow: {self staticLabel: aByteString. self text: aByteSymbol}! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/4/2013 23:25'!
title: aByteString text: aByteSymbol width: aNumber
	^self groupedRow: {self staticLabel: aByteString. self text: aByteSymbol width: aNumber}! !

!QuickPrototyping methodsFor: 'creating widget' stamp: 'HwaJong 1/31/2013 23:55'!
window: aString content: aPanelMorph 
	|window|
	aPanelMorph beShrinkWrapping.
	window := aPanelMorph openInWindowLabeled: aString.
	^window! !

!Morph methodsFor: '*quickprototypingcommon' stamp: 'HwaJong 8/18/2013 14:36'!
beHorizontalFilling
	self beHorizontalFillingWithHeight: self height! !

!Morph methodsFor: '*quickprototypingcommon' stamp: 'HwaJong 3/3/2013 10:14'!
beHorizontalFillingWithHeight: aSmallInteger 
	self hResizing: #spaceFill.
	self vResizing: #rigid.
	self height: aSmallInteger! !

!Morph methodsFor: '*quickprototypingcommon' stamp: 'HwaJong 2/5/2013 17:42'!
beRigid
	self hResizing: #rigid.
	self vResizing: #rigid.! !

!Morph methodsFor: '*quickprototypingcommon' stamp: 'HwaJong 1/31/2013 23:48'!
beShrinkWrapping
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.! !

!Morph methodsFor: '*quickprototypingcommon' stamp: 'HwaJong 1/20/2013 00:44'!
beSpaceFilling
	self hResizing: #spaceFill.
	self vResizing: #spaceFill.! !

!Morph methodsFor: '*quickprototypingcommon' stamp: 'HwaJong 1/20/2013 00:43'!
beVerticalFillingWithWidth: aSmallInteger 
	self hResizing: #rigid.
	self vResizing: #spaceFill.
	self width: aSmallInteger! !

!SequenceableCollection methodsFor: '*quickprototypingcommon' stamp: 'HwaJong 1/3/2013 12:24'!
columnPanelMorph
	^(UITheme builder
		newColumn: self)
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap! !

!SequenceableCollection methodsFor: '*quickprototypingcommon' stamp: 'HwaJong 1/3/2013 12:26'!
panelMorphFrom2DArray
	^(self collect: [:each| each rowPanelMorph]) columnPanelMorph! !

!SequenceableCollection methodsFor: '*quickprototypingcommon' stamp: 'HwaJong 1/3/2013 12:22'!
rowPanelMorph
	^(UITheme builder newRow: self)
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap! !
